// Created with MonoDevelop
//
//    QuickStep: Acquire, view and identify spectra 
//    Copyright (C) 2022 Torsten Schache, Hiperscan GmbH Dresden, Germany
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.


using Gtk;
using Hiperscan.Unix;
using Hiperscan.GuiExtensions.Dialog;

namespace Hiperscan.GtkExtensions.StandardDialogs
{
    public class DontShowAgainQuestionDialog : StandardDialog
    {
        public DontShowAgainQuestionDialog(Gtk.Window parent, DialogArgsTempleate arg) : base(parent, arg)
        {
            this.DontShowAgainMessage = arg.DontShowAgainMesssage.Replace("&", "&#38;");

            if (string.IsNullOrEmpty(this.DontShowAgainMessage))
                this.DontShowAgainMessage = Catalog.GetString("Do not show this dialogue again");

            if (string.IsNullOrEmpty(this.Title))
                this.Title = Catalog.GetString("Note");
        }

        public static void Run(Gtk.Window parent, DialogArgsTempleate arg)
        {
            var tmp = new DontShowAgainQuestionDialog(parent, arg);
            if (tmp.Arg.DontShowAgain)
            {
                tmp.Arg.Response = DialogRespnseType.None;
            }
            else
            {
               tmp.ShowDialog(Gtk.DialogFlags.Modal,
                                Gtk.MessageType.Question,
                                Gtk.ButtonsType.YesNo);
            }
        }

        protected override void ExtendDialog(MessageDialog mdlg)
        {
            CheckButton cb = new CheckButton(this.DontShowAgainMessage)
            {
                Active = false,
                CanFocus = false,
            };

            mdlg.VBox.PackStart(cb);
            cb.Show();

            cb.Toggled += (sender, e) => this.Arg.DontShowAgain = cb.Active;
        }

        private string DontShowAgainMessage { get; set; }
    }
}
